% billateral key exchange with public key protocol
% (approx. 9s to verify)

% Initiator Strand
initiator(A,B,Na,Nb,Kab,[ 
   label_Initiator(A,B,Na,Nb,Kab),
   [
   send([B, [Nb, B]*pk(A)]),
   recv([sha(Nb), [Na, [A, Kab]]]*pk(B)),   
   send(sha(Na)+Kab)
   ]
 ]).

% Responder Strand
responder(A,B,Na,Nb,Kab,[ 
   label_Responder(A,B,Na,Nb,Kab),
   [
   recv([B, [Nb, B]*pk(A)]),
   send([sha(Nb), [Na, [A, Kab]]]*pk(B)),   
   recv(sha(Na)+Kab)
   ]
 ]).

% Secrecy Strand
secrecy(N,[
   label_Secrecy(N),
   [recv(N)]
]).

% Semibundle 
% [_,[]] means 'force to finish this strand
semibundle([St,St2,St3,Sa1,Sb1,Sa2,Sb2,Sa3,Sb3],[[_,[]],_,_,_,_,_,_,_,_],[a,b,e]) 
:-
   initiator(a,b,na1,_,kab1,Sa1),
   responder(a,b,_,nb1 ,_,Sb1),

   initiator(a,b,na2,_,kab2,Sa2),
   responder(a,b,_,nb2 ,_,Sb2),

   initiator(a,b,na3,_,kab3,Sa3),
   responder(a,b,_,nb3 ,_,Sb3),

   secrecy(nb1, St),
   secrecy(nb2, St2),
   secrecy(nb3, St3).

